searchNodes=[{"doc":"Implements an Ueberauth.Strategy for AWS Cognito.Several options are available for configuring the strategy. The main keys you need to worry about are:auth_domainclient_idclient_secretuser_pool_idaws_regionThese should all be available from your AWS Cognito setup. Additionally, there are a couple of options specifying what modules to use for some particular functions:http_clientjwt_verifierThese are mainly used for dependency injection when testing and users of this library shouldn't have to concern themselves with them.","ref":"Ueberauth.Strategy.Cognito.html","title":"Ueberauth.Strategy.Cognito","type":"module"},{"doc":"","ref":"Ueberauth.Strategy.Cognito.html#auth/1","title":"Ueberauth.Strategy.Cognito.auth/1","type":"function"},{"doc":"Returns standard Ueberauth.Auth.Credentials struct. The other key will be a map including a groups key, which is a list of any groups the user is associated with in Cognito","ref":"Ueberauth.Strategy.Cognito.html#credentials/1","title":"Ueberauth.Strategy.Cognito.credentials/1","type":"function"},{"doc":"","ref":"Ueberauth.Strategy.Cognito.html#default_options/0","title":"Ueberauth.Strategy.Cognito.default_options/0","type":"function"},{"doc":"The raw_info key of the returned struct includes everything from the raw Cognito response in cognito_id_token.","ref":"Ueberauth.Strategy.Cognito.html#extra/1","title":"Ueberauth.Strategy.Cognito.extra/1","type":"function"},{"doc":"Handle the callback step of the strategy.Note that if the refresh_token param set in your conn, this will attempt to use the given refresh token rather than the normal Cognito flow.","ref":"Ueberauth.Strategy.Cognito.html#handle_callback!/1","title":"Ueberauth.Strategy.Cognito.handle_callback!/1","type":"function"},{"doc":"Handles the cleanup step of the strategy.","ref":"Ueberauth.Strategy.Cognito.html#handle_cleanup!/1","title":"Ueberauth.Strategy.Cognito.handle_cleanup!/1","type":"function"},{"doc":"Handle the request step of the strategy.","ref":"Ueberauth.Strategy.Cognito.html#handle_request!/1","title":"Ueberauth.Strategy.Cognito.handle_request!/1","type":"function"},{"doc":"Fetches the fields to populate the info section of the Ueberauth.Auth struct.","ref":"Ueberauth.Strategy.Cognito.html#info/1","title":"Ueberauth.Strategy.Cognito.info/1","type":"function"},{"doc":"Returns the username given in the Cognito response.","ref":"Ueberauth.Strategy.Cognito.html#uid/1","title":"Ueberauth.Strategy.Cognito.uid/1","type":"function"},{"doc":"Utilities for working with JSON Web Tokens","ref":"Ueberauth.Strategy.Cognito.JwtVerifier.html","title":"Ueberauth.Strategy.Cognito.JwtVerifier","type":"module"},{"doc":"Verifies that a JWT is valid: the signature is correct, and the audience is the AWS client_id","ref":"Ueberauth.Strategy.Cognito.JwtVerifier.html#verify/3","title":"Ueberauth.Strategy.Cognito.JwtVerifier.verify/3","type":"function"},{"doc":"UeberauthCognito An Ueberauth Strategy for AWS Cognito.","ref":"readme.html","title":"UeberauthCognito","type":"extras"},{"doc":"Add :ueberauth and :ueberauth_cognito to your mix.exs:defp deps do [ # ... {:ueberauth, &quot;~&gt; 0.6&quot;}, {:ueberauth_cognito, &quot;~&gt; 0.1&quot;} ] endConfigure Ueberauth to use this strategy:config :ueberauth, Ueberauth, providers: [ cognito: {Ueberauth.Strategy.Cognito, []} ]and configure the required values:config :ueberauth, Ueberauth.Strategy.Cognito, auth_domain: {System, :get_env, [&quot;COGNITO_DOMAIN&quot;]}, client_id: {System, :get_env, [&quot;COGNITO_CLIENT_ID&quot;]}, client_secret: {System, :get_env, [&quot;COGNITO_CLIENT_SECRET&quot;]}, user_pool_id: {System, :get_env, [&quot;COGNITO_USER_POOL_ID&quot;]}, aws_region: {System, :get_env, [&quot;COGNITO_AWS_REGION&quot;]} # e.g. &quot;us-east-1&quot;The values can be configured with an MFA, or simply a string.Add the routes to the router:scope &quot;/auth&quot;, SignsUiWeb do pipe_through([:redirect_prod_http, :browser]) get(&quot;/:provider&quot;, AuthController, :request) get(&quot;/:provider/callback&quot;, AuthController, :callback) endand create the corresponding controller:defmodule SignsUiWeb.AuthController do use SignsUiWeb, :controller plug(Ueberauth) def callback(%{assigns: %{ueberauth_failure: _fails}} = conn, _params) do # what to do if sign in fails end def callback(%{assigns: %{ueberauth_auth: auth}} = conn, _params) do # sign the user in or something. # auth is a `%Ueberauth.Auth{}` struct, with Cognito token info send_resp(conn, 200, &quot;Welcome, \#{auth.uid}&quot;) end endNote that the entry in the router defines the authentication callback URL, and will need to be whitelisted in the AWS Cognito User Pools settings.","ref":"readme.html#installation","title":"UeberauthCognito - Installation","type":"extras"},{"doc":"If you wish to use Ueberauth in multiple OTP apps, and configure each instance of Ueberauth with a different list of Providers and settings, you will need to do some things differently. When providing configuration for Ueberauth, you should set anything that differs by OTP app under the name of your OTP app, for example:config :my_app, Ueberauth, providers: [ cognito: {Ueberauth.Strategy.Cognito, []} ]and configure the required values for the provider (make sure to use the same otp_app name)config :my_app, Ueberauth.Strategy.Cognito, auth_domain: {System, :get_env, [&quot;COGNITO_DOMAIN&quot;]}, client_id: {System, :get_env, [&quot;COGNITO_CLIENT_ID&quot;]}, client_secret: {System, :get_env, [&quot;COGNITO_CLIENT_SECRET&quot;]}, user_pool_id: {System, :get_env, [&quot;COGNITO_USER_POOL_ID&quot;]}, aws_region: {System, :get_env, [&quot;COGNITO_AWS_REGION&quot;]} # e.g. &quot;us-east-1&quot;In your controller, when using the Ueberauth plug, you should pass the :otp_app option, for example:defmodule SignsUiWeb.AuthController do use SignsUiWeb, :controller plug(Ueberauth, otp_app: :my_app) ...","ref":"readme.html#configuration-of-settings-per-otp-app","title":"UeberauthCognito - Configuration of settings per OTP app","type":"extras"},{"doc":"Cognito supports using refresh tokens to automatically obtain new access tokens for users whose access tokens expire. If your application has a refresh token handy, you can redirect to the callback URL with the refresh_token param set, and Ueberauth will attempt to use the given refresh token value to obtain a fresh access token.The refresh token for an access token is issued at the same time as the access token, and is available in the Ueberauth.Auth.Credentials struct. Whether to use refresh tokens, and where to store them if used, is an implementation detail. Your first instinct might be to store them in a cookie, but they can sometimes exceed the maximum possible cookie size. An alternative is to store an identifier (which could be a username, or simply a random nonce) in a cookie, and create a GenServer that maps these identifiers to refresh tokens. This has the advantage of not revealing the refresh tokens to the end user, if this is a consideration.","ref":"readme.html#refreshing-access-tokens","title":"UeberauthCognito - Refreshing access tokens","type":"extras"}]